<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `src/hlo_json/derive/derivation.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>derivation.rs - source</title><link rel="stylesheet" type="text/css" href="../../../../normalize.css"><link rel="stylesheet" type="text/css" href="../../../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../../../light.css"  id="themeStyle"><link rel="stylesheet" type="text/css" href="../../../../dark.css" disabled ><link rel="stylesheet" type="text/css" href="../../../../ayu.css" disabled ><script id="default-settings"></script><script src="../../../../storage.js"></script><noscript><link rel="stylesheet" href="../../../../noscript.css"></noscript><link rel="icon" type="image/svg+xml" href="../../../../favicon.svg">
<link rel="alternate icon" type="image/png" href="../../../../favicon-16x16.png">
<link rel="alternate icon" type="image/png" href="../../../../favicon-32x32.png"><style type="text/css">#crate-search{background-image:url("../../../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 8]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu">&#9776;</div><a href='../../../../HPGO/index.html'><div class='logo-container rust-logo'><img src='../../../../rust-logo.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!" aria-haspopup="menu"><img src="../../../../brush.svg" width="18" alt="Pick another theme!"></button><div id="theme-choices" role="menu"></div></div><script src="../../../../theme.js"></script><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><button type="button" class="help-button">?</button>
                <a id="settings-menu" href="../../../../settings.html"><img src="../../../../wheel.svg" width="18" alt="Change settings"></a></div></form></nav><section id="main" class="content"><pre class="line-numbers"><span id="1">  1</span>
<span id="2">  2</span>
<span id="3">  3</span>
<span id="4">  4</span>
<span id="5">  5</span>
<span id="6">  6</span>
<span id="7">  7</span>
<span id="8">  8</span>
<span id="9">  9</span>
<span id="10"> 10</span>
<span id="11"> 11</span>
<span id="12"> 12</span>
<span id="13"> 13</span>
<span id="14"> 14</span>
<span id="15"> 15</span>
<span id="16"> 16</span>
<span id="17"> 17</span>
<span id="18"> 18</span>
<span id="19"> 19</span>
<span id="20"> 20</span>
<span id="21"> 21</span>
<span id="22"> 22</span>
<span id="23"> 23</span>
<span id="24"> 24</span>
<span id="25"> 25</span>
<span id="26"> 26</span>
<span id="27"> 27</span>
<span id="28"> 28</span>
<span id="29"> 29</span>
<span id="30"> 30</span>
<span id="31"> 31</span>
<span id="32"> 32</span>
<span id="33"> 33</span>
<span id="34"> 34</span>
<span id="35"> 35</span>
<span id="36"> 36</span>
<span id="37"> 37</span>
<span id="38"> 38</span>
<span id="39"> 39</span>
<span id="40"> 40</span>
<span id="41"> 41</span>
<span id="42"> 42</span>
<span id="43"> 43</span>
<span id="44"> 44</span>
<span id="45"> 45</span>
<span id="46"> 46</span>
<span id="47"> 47</span>
<span id="48"> 48</span>
<span id="49"> 49</span>
<span id="50"> 50</span>
<span id="51"> 51</span>
<span id="52"> 52</span>
<span id="53"> 53</span>
<span id="54"> 54</span>
<span id="55"> 55</span>
<span id="56"> 56</span>
<span id="57"> 57</span>
<span id="58"> 58</span>
<span id="59"> 59</span>
<span id="60"> 60</span>
<span id="61"> 61</span>
<span id="62"> 62</span>
<span id="63"> 63</span>
<span id="64"> 64</span>
<span id="65"> 65</span>
<span id="66"> 66</span>
<span id="67"> 67</span>
<span id="68"> 68</span>
<span id="69"> 69</span>
<span id="70"> 70</span>
<span id="71"> 71</span>
<span id="72"> 72</span>
<span id="73"> 73</span>
<span id="74"> 74</span>
<span id="75"> 75</span>
<span id="76"> 76</span>
<span id="77"> 77</span>
<span id="78"> 78</span>
<span id="79"> 79</span>
<span id="80"> 80</span>
<span id="81"> 81</span>
<span id="82"> 82</span>
<span id="83"> 83</span>
<span id="84"> 84</span>
<span id="85"> 85</span>
<span id="86"> 86</span>
<span id="87"> 87</span>
<span id="88"> 88</span>
<span id="89"> 89</span>
<span id="90"> 90</span>
<span id="91"> 91</span>
<span id="92"> 92</span>
<span id="93"> 93</span>
<span id="94"> 94</span>
<span id="95"> 95</span>
<span id="96"> 96</span>
<span id="97"> 97</span>
<span id="98"> 98</span>
<span id="99"> 99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
</pre><div class="example-wrap"><pre class="rust ">
<span class="kw">use</span> <span class="kw">crate</span>::<span class="ident">hlo_json</span>::<span class="ident">error</span>::<span class="ident">DeriveError</span>::<span class="kw-2">*</span>;
<span class="kw">use</span> <span class="kw">crate</span>::<span class="ident">hlo_json</span>::<span class="ident">hlo_ast</span>::<span class="kw-2">*</span>;
<span class="kw">use</span> <span class="ident">rayon</span>::<span class="ident">prelude</span>::<span class="kw-2">*</span>;
<span class="kw">use</span> <span class="ident">std</span>::<span class="ident">collections</span>::<span class="ident">HashMap</span>;
<span class="kw">use</span> <span class="ident">std</span>::<span class="ident">error</span>::<span class="ident">Error</span>;
<span class="kw">use</span> <span class="ident">std</span>::<span class="ident">time</span>::<span class="ident">Instant</span>;

<span class="kw">pub</span> <span class="kw">type</span> <span class="ident">Split</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> <span class="op">=</span> (<span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">str</span>, <span class="ident">i8</span>);
<span class="kw">pub</span> <span class="kw">type</span> <span class="ident">DeriveCache</span> <span class="op">=</span> <span class="ident">HashMap</span><span class="op">&lt;</span><span class="ident">InstPos</span>, <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">HashMap</span><span class="op">&lt;</span><span class="ident">String</span>, <span class="ident">i8</span><span class="op">&gt;</span><span class="op">&gt;</span><span class="op">&gt;</span>;

<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Derivation</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
    <span class="kw">pub</span> <span class="ident">lazy_cache</span>: <span class="ident">bool</span>,
    <span class="kw">pub</span> <span class="ident">derive_cache</span>: <span class="ident">HashMap</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">Instruction</span>, <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">HashMap</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">str</span>, <span class="ident">i8</span><span class="op">&gt;</span><span class="op">&gt;</span><span class="op">&gt;</span>,
    <span class="kw">pub</span> <span class="ident">ast</span>: <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">HLORoot</span><span class="op">&gt;</span>,
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> <span class="ident">Derivation</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">new</span>() <span class="op">-</span><span class="op">&gt;</span> <span class="ident">Derivation</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
        <span class="ident">Derivation</span> {
            <span class="ident">derive_cache</span>: <span class="ident">HashMap</span>::<span class="ident">new</span>(),
            <span class="ident">lazy_cache</span>: <span class="bool-val">false</span>,
            <span class="ident">ast</span>: <span class="prelude-val">None</span>,
        }
    }

    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">new_with_ast</span>(<span class="ident">ast</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">HLORoot</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">Derivation</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">d</span> <span class="op">=</span> <span class="ident">Derivation</span> {
            <span class="ident">derive_cache</span>: <span class="ident">HashMap</span>::<span class="ident">new</span>(),
            <span class="ident">lazy_cache</span>: <span class="bool-val">false</span>,
            <span class="ident">ast</span>: <span class="prelude-val">Some</span>(<span class="ident">ast</span>),
        };
        <span class="ident">d</span>.<span class="ident">cache_all_derive</span>(<span class="ident">ast</span>).<span class="ident">unwrap</span>();
        <span class="ident">d</span>
    }

    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">cache_ast</span>(
        <span class="ident">ast_root</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">HLORoot</span>,
    ) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">Vec</span><span class="op">&lt;</span>(<span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">Instruction</span>, <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">HashMap</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">str</span>, <span class="ident">i8</span><span class="op">&gt;</span><span class="op">&gt;</span>)<span class="op">&gt;</span>, <span class="ident">Box</span><span class="op">&lt;</span><span class="kw">dyn</span> <span class="ident">Error</span><span class="op">&gt;</span><span class="op">&gt;</span> {
        <span class="kw">let</span> <span class="ident">result</span> <span class="op">=</span> <span class="ident">ast_root</span>
            .<span class="ident">functions</span>
            .<span class="ident">par_iter</span>()
            .<span class="ident">flat_map</span>(<span class="op">|</span><span class="ident">f</span><span class="op">|</span> {
                <span class="ident">f</span>.<span class="ident">body</span>
                    .<span class="ident">par_iter</span>()
                    .<span class="ident">map</span>(<span class="op">|</span><span class="ident">i</span><span class="op">|</span> (<span class="ident">i</span>, <span class="self">Self</span>::<span class="ident">d</span>(<span class="ident">i</span>).<span class="ident">unwrap</span>())) <span class="comment">// TODO: use ? after finishing all d_s</span>
                    .<span class="ident">collect</span>::<span class="op">&lt;</span><span class="ident">Vec</span><span class="op">&lt;</span>(<span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">Instruction</span>, <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">HashMap</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">str</span>, <span class="ident">i8</span><span class="op">&gt;</span><span class="op">&gt;</span>)<span class="op">&gt;</span><span class="op">&gt;</span>()
            })
            .<span class="ident">collect</span>::<span class="op">&lt;</span><span class="ident">Vec</span><span class="op">&lt;</span>(<span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">Instruction</span>, <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">HashMap</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">str</span>, <span class="ident">i8</span><span class="op">&gt;</span><span class="op">&gt;</span>)<span class="op">&gt;</span><span class="op">&gt;</span>();
        <span class="prelude-val">Ok</span>(<span class="ident">result</span>)
    }

    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">cache_all_derive</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>, <span class="ident">ast_root</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">HLORoot</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span>(), <span class="ident">Box</span><span class="op">&lt;</span><span class="kw">dyn</span> <span class="ident">Error</span><span class="op">&gt;</span><span class="op">&gt;</span> {
        <span class="kw">let</span> <span class="ident">now</span> <span class="op">=</span> <span class="ident">Instant</span>::<span class="ident">now</span>();
        <span class="self">self</span>.<span class="ident">derive_cache</span>.<span class="ident">par_extend</span>(<span class="self">Self</span>::<span class="ident">cache_ast</span>(<span class="ident">ast_root</span>)<span class="question-mark">?</span>);
        <span class="macro">println</span><span class="macro">!</span>(
            <span class="string">&quot;[derive]\t Derivation AOT Cache for AST... {}ms&quot;</span>,
            <span class="ident">now</span>.<span class="ident">elapsed</span>().<span class="ident">as_millis</span>()
        );
        <span class="prelude-val">Ok</span>(())
    }

    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">cache_export</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">DeriveCache</span>, <span class="ident">Box</span><span class="op">&lt;</span><span class="kw">dyn</span> <span class="ident">Error</span><span class="op">&gt;</span><span class="op">&gt;</span> {
        <span class="kw">if</span> <span class="self">self</span>.<span class="ident">derive_cache</span>.<span class="ident">len</span>() <span class="op">=</span><span class="op">=</span> <span class="number">0</span> {
            <span class="macro">println</span><span class="macro">!</span>(<span class="string">&quot;[derive]\t cache_all_derive not run before trying to get the result&quot;</span>);
            <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="ident">Box</span>::<span class="ident">new</span>(<span class="ident">CacheNotAvailable</span>()));
        }
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">result</span>: <span class="ident">HashMap</span><span class="op">&lt;</span><span class="ident">InstPos</span>, <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">HashMap</span><span class="op">&lt;</span><span class="ident">String</span>, <span class="ident">i8</span><span class="op">&gt;</span><span class="op">&gt;</span><span class="op">&gt;</span> <span class="op">=</span> <span class="ident">HashMap</span>::<span class="ident">new</span>();
        <span class="ident">result</span>.<span class="ident">par_extend</span>(<span class="self">self</span>.<span class="ident">derive_cache</span>.<span class="ident">par_iter</span>().<span class="ident">map</span>(<span class="op">|</span>(<span class="ident">k</span>, <span class="ident">v</span>)<span class="op">|</span> {
            <span class="kw">let</span> <span class="ident">inst</span>: <span class="ident">Instruction</span> <span class="op">=</span> <span class="ident">k</span>.<span class="ident">clone</span>().<span class="ident">to_owned</span>();
            <span class="kw">let</span> <span class="ident">pos</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">ast</span>.<span class="ident">unwrap</span>().<span class="ident">inst_pos</span>[<span class="kw-2">&amp;</span><span class="ident">inst</span>];
            <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">v_exp</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">HashMap</span><span class="op">&lt;</span><span class="ident">String</span>, <span class="ident">i8</span><span class="op">&gt;</span><span class="op">&gt;</span> <span class="op">=</span> <span class="macro">vec</span><span class="macro">!</span>[];
            <span class="kw">for</span> <span class="ident">m</span> <span class="kw">in</span> <span class="ident">v</span> {
                <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">m_exp</span>: <span class="ident">HashMap</span><span class="op">&lt;</span><span class="ident">String</span>, <span class="ident">i8</span><span class="op">&gt;</span> <span class="op">=</span> <span class="ident">HashMap</span>::<span class="ident">new</span>();
                <span class="kw">for</span> (<span class="ident">kk</span>, <span class="ident">vv</span>) <span class="kw">in</span> <span class="ident">m</span> {
                    <span class="ident">m_exp</span>.<span class="ident">insert</span>(<span class="ident">kk</span>.<span class="ident">to_string</span>(), <span class="kw-2">*</span><span class="ident">vv</span>);
                }
                <span class="ident">v_exp</span>.<span class="ident">push</span>(<span class="ident">m_exp</span>);
            }
            (<span class="ident">pos</span>, <span class="ident">v_exp</span>)
        }));
        <span class="prelude-val">Ok</span>(<span class="ident">result</span>)
    }

    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">derive</span>(
        <span class="ident">derive_cache</span>: <span class="kw-2">&amp;</span><span class="ident">DeriveCache</span>,
        <span class="ident">func_id</span>: <span class="ident">usize</span>,
        <span class="ident">inst_id</span>: <span class="ident">usize</span>,
    ) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">HashMap</span><span class="op">&lt;</span><span class="ident">String</span>, <span class="ident">i8</span><span class="op">&gt;</span><span class="op">&gt;</span>, <span class="ident">Box</span><span class="op">&lt;</span><span class="kw">dyn</span> <span class="ident">Error</span><span class="op">&gt;</span><span class="op">&gt;</span> {
        <span class="kw">if</span> <span class="ident">derive_cache</span>.<span class="ident">contains_key</span>(<span class="kw-2">&amp;</span>(<span class="ident">func_id</span>, <span class="ident">inst_id</span>)) {
            <span class="prelude-val">Ok</span>(<span class="kw-2">&amp;</span><span class="ident">derive_cache</span>[<span class="kw-2">&amp;</span>(<span class="ident">func_id</span>, <span class="ident">inst_id</span>)])
        } <span class="kw">else</span> {
            <span class="prelude-val">Err</span>(<span class="ident">Box</span>::<span class="ident">new</span>(<span class="ident">InstNotInCache</span>(<span class="macro">format</span><span class="macro">!</span>(
                <span class="string">&quot;{:?}&quot;</span>,
                (<span class="ident">func_id</span>, <span class="ident">inst_id</span>)
            ))))
        }
    }

    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">derive_infer</span>(
        <span class="kw-2">&amp;</span><span class="self">self</span>,
        <span class="ident">inst</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">Instruction</span>,
    ) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">HashMap</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">str</span>, <span class="ident">i8</span><span class="op">&gt;</span><span class="op">&gt;</span>, <span class="ident">Box</span><span class="op">&lt;</span><span class="kw">dyn</span> <span class="ident">Error</span><span class="op">&gt;</span><span class="op">&gt;</span> {
        <span class="kw">if</span> <span class="self">self</span>.<span class="ident">derive_cache</span>.<span class="ident">contains_key</span>(<span class="ident">inst</span>) {
            <span class="prelude-val">Ok</span>(<span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">derive_cache</span>[<span class="ident">inst</span>])
        } <span class="kw">else</span> {
            <span class="prelude-val">Err</span>(<span class="ident">Box</span>::<span class="ident">new</span>(<span class="ident">InstNotInCache</span>(<span class="macro">format</span><span class="macro">!</span>(<span class="string">&quot;{:?}&quot;</span>, <span class="ident">inst</span>))))
        }
    }
}
</pre></div>
</section><section id="search" class="content hidden"></section><section class="footer"></section><script>window.rootPath = "../../../../";window.currentCrate = "HPGO";</script><script src="../../../../main.js"></script><script src="../../../../source-script.js"></script><script src="../../../../source-files.js"></script><script defer src="../../../../search-index.js"></script></body></html>